var lWarn = {logln:function (o){}}; 
var lInfo = {logln:function (o){}};

var LOGFILE_NAME = "led-wizard.log";
lWarn = new Logger(LOGFILE_NAME);
lInfo = new Logger(LOGFILE_NAME);



function cleanUp() {
	if (Property.getNode('programmInProgress')!=null)
		if (Property.getProperty('programmInProgress')==true) {
			var myID=Property.getNode('programmInProgress').getParent().getName();
			lWarn.logln('cleanup requested for ' + Property.getNode('programmInProgress').getPath()+ ' but programming is scheduled ... but this will be reseted in 6 hours after all');
			new Event(myID.replace('manufacture','query'),{actions:'cleanup'}).raise();
		}
			
	if (Property.getNode('myData')==null)
		return;
	var oArray=Property.getNode('myData').getChildren();
	for (var iIndex=0;iIndex<oArray.length;iIndex++) {
		try {
			oArray[iIndex].removeChild('curves');
		} catch (e) {
			
		}
	}
}

if (raisedEvent.parameter.actions!=null) {
	if (raisedEvent.parameter.actions=='cleanup') {
		if (Property.getNode('programmInProgress')!=null)
			Property.getNode('programmInProgress').getParent().removeChild('programmInProgress');
		cleanUp();
	}
	if (raisedEvent.parameter.actions=='programmCurve') {
		Property.load();
		Property.setProperty('programmInProgress',true);
		new Event('led-wizard.prog',{actions:'programmCurveStartQueue',retry:true}).raise();		
	} else
	if (raisedEvent.parameter.actions=='loadProperty') {
		Property.load();
		var illuminants=[];
		var oArray=Property.getNode('myData').getChildren();
		for (var iIndex=0;iIndex<oArray.length;iIndex++) {
			if (oArray[iIndex].getChild('id')!=null)
				illuminants.push(oArray[iIndex].getChild('id').getValue());
		}
		Property.setProperty('/scripts/led-wizard/references/' + raisedEvent.parameter.supplierID,JSON.stringify(illuminants));
		cleanUp();
	}
	
} else {
	lInfo.logln('start query');
	Property.load();
	if (raisedEvent.parameter.illuminantID!=null) {
		var iIlluminant=raisedEvent.parameter.illuminantID;
		
		var curvesData=Property.getProperty('myData/illuminant'+iIlluminant+'/curves');
		if (curvesData==null) {
			lInfo.logln('curve is null');
			new Event('led-wizard.answer',{'type':'curves','illumant':iIlluminant,'data':'[]'}).raise();
		} else {
			lInfo.logln('curve is '+curvesData);
			new Event('led-wizard.answer',{'type':'curves','illumant':iIlluminant,'data':curvesData}).raise();
		}
	}
	cleanUp();
}
